/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef FBGENERATORJOB_H
#define FBGENERATORJOB_H
#include <kjob.h>
#include <kdatetime.h>
#include <kimap/session.h>
#include <kimap/fetchjob.h>
#include <kolabfreebusy.h>
#include "kolabjob.h"

class FBGeneratorTest;

class FBGeneratorJob: public KolabJob
{
    Q_OBJECT
    friend class FBGeneratorTest;
public:
    explicit FBGeneratorJob(const SessionSettings &settings, bool store, QObject* parent = 0);

    Kolab::Freebusy getFreebusy();
    void setTimeFrame(const KDateTime&, const KDateTime&);
private Q_SLOTS:
    void onFetchFBDone(KJob *job);
    void onGenerateFBDone(KJob*);
    void onModDone(KJob*);
protected:
    virtual QStringList requiredFolders();
    void startGenerateFBJob();
private:
    virtual void startWork();
    void storeFBObject();

    QString mFreebusyFolder;
    QStringList mEventFolders;

    Kolab::Freebusy mFreebusy;
    bool mStore;
    qint64 mOldImapUid;
    KIMAP::MessageFlags mOldFlags;

    KDateTime mStartOfTimeFrame;
    KDateTime mEndOfTimeFrame;
};

#endif // FBGENERATORJOB_H
