/*
 * Copyright (C) 2014  Sandro Knauß <knauss@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef FBGENERATORFOLDERTEST_H
#define FBGENERATORFOLDERTEST_H

#include <QObject>

#include "testlib/testutils.h"

class KolabAccount;
class KDateTime;

class FBGeneratorFolderTest: public QObject
{
    Q_OBJECT
public:
    explicit FBGeneratorFolderTest(QObject* parent = 0);

private slots:
    void testGenerator();
    void testGeneratorEmpty();
    void testFailedNotFound();
    void testFailedSystemIoError();
    void testSetTimeframe();
private:
    Kolab::Freebusy executeGeneration(const QString&, KDateTime, KDateTime);
    void executeGenerationError(const QString&, KDateTime, KDateTime, QString);
    void compareFreeBusy(Kolab::Freebusy fb1, Kolab::Freebusy fb2);

    QString user;

};

#endif