/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GETUSERLISTJOB_H
#define GETUSERLISTJOB_H
#include <kjob.h>
#include <qstringlist.h>
#include <qset.h>
#include <kimap/session.h>
#include <kimap/listjob.h>

class GetUserListJob: public KJob
{
    Q_OBJECT
public:
    explicit GetUserListJob(KIMAP::Session* session, QObject* parent = 0);
    virtual void start();
    QStringList getUserList() const;
    void setFilterDomain(const QString &);

private:
    QString mFilterDomain;
    KIMAP::Session *mSession;
    QSet<QString> mNames;

private slots:
    void onListDone(KJob*);
    void mailBoxesReceived(const QList<KIMAP::MailBoxDescriptor> &, const QList<QList<QByteArray> > &);
//     void onNamespacesTestDone(KJob*);
};

#endif // GETUSERLISTJOB_H
