/*
 * Copyright (C) 2012  Christian Mollekopf <mollekopf@kolabsys.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SESSIONFACTORY_H
#define SESSIONFACTORY_H
#include <QString>
#include <kimap/session.h>
#include "uiproxy.h"

static KIMAP::Session *createSession(const QString &host, qint16 port, QObject *parent)
{
    KIMAP::Session *session = new KIMAP::Session(host, port, parent);
    session->setUiProxy(KIMAP::SessionUiProxy::Ptr(new UiProxy()));
    session->setTimeout(300);
    return session;
}

#endif // OBJECT_H
